//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "VideoFromBMPorJPEGfiles_.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VidGrab"
#pragma resource "*.dfm"
TForm1 *Form1;

__fastcall TFileSearch::TFileSearch (TComponent* Owner): TComponent (Owner)
{
   Opened = False;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TFileSearch::FirstFile (AnsiString SearchPath, AnsiString FileKind)
{
   AnsiString Result = "";

   if (Opened) {
      Close(); // let's close any previous opened search
   }

   if (SearchPath.Length() > 0) { // let's add a trailing slash if required
      if (SearchPath[SearchPath.Length()] == '\\') {
         Path = SearchPath;
      }
      else {
         Path = SearchPath + "\\";
      }
   }
   else {
      Path = ".\\";
   }

   if (FindFirst (Path + FileKind, faAnyFile, SearchRec) == 0) {
      Result = Path + SearchRec.Name;
      Opened = True;
   }
   return Result;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TFileSearch::NextFile ()
{
   AnsiString Result = "";
   if (Opened) {
      if (FindNext (SearchRec) == 0) {
         Result = Path + SearchRec.Name;
      }
      else {
         Close();
      }
   }
   return Result;
}
//---------------------------------------------------------------------------

void __fastcall TFileSearch::Close ()
{
   if (Opened) {
      FindClose (SearchRec);
      Opened = False;
   }
}
//---------------------------------------------------------------------------

__fastcall TFileSearch::~TFileSearch ()
{
   Close();
   //TComponent::~TComponent ();
}
//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   SearchForFiles = new TFileSearch (this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnStartPreviewClick(TObject *Sender)
{
   VideoGrabber->VideoSource = vs_JPEGsOrBitmaps;
   VideoGrabber->FrameRate = StrToIntDef (edtFrameRate->Text, 15);
   VideoGrabber->StartPreview();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnStartRecordingClick(TObject *Sender)
{
   VideoGrabber->VideoSource = vs_JPEGsOrBitmaps;
   VideoGrabber->FrameRate = StrToIntDef (edtFrameRate->Text, 15);
   VideoGrabber->StartRecording();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnStopClick(TObject *Sender)
{
   VideoGrabber->Stop();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnPlayClick(TObject *Sender)
{
   VideoGrabber->PlayerFileName = VideoGrabber->Last_Recording_FileName;
   VideoGrabber->OpenPlayer();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabberFrameProgress(TObject *Sender,
      DWORD FrameNumber, Int64 FrameTime, int FrameId)
{
   edtFrameProgress->Text = "frame # " + IntToStr (FrameNumber);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabberLog(TObject *Sender, TLogType LogType,
      AnsiString Severity, AnsiString InfoMsg)
{
   mmoLog->Lines->Add (InfoMsg);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::VideoGrabberVideoFromBitmapsFormatNeeded(
      TObject *Sender, HBITMAP &BitmapHandle, AnsiString &BMPorJPEGFile)
{
   // you can pass to this event:
   // - either the path to a BMP file or a JPEG file (this is the case in this example)
   // - either a the HBITMAP handle of a bitmap

   if (rdgSearchForBMPorJPEG->ItemIndex == 0) {
      BMPorJPEGFile = SearchForFiles->FirstFile (edtFilesLocation->Text, "*.bmp");
   }
   else {
      BMPorJPEGFile = SearchForFiles->FirstFile (edtFilesLocation->Text, "*.jpg");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoGrabberVideoFromBitmapsNextFrameNeeded(
      TObject *Sender, bool FirstSample, HBITMAP &BitmapHandle,
      AnsiString &BMPorJPEGFile, bool &EndOfData)
{
   // you can pass to this event:
   // - either the path to a BMP file or a JPEG file (this is the case in this example)
   // - either a the HBITMAP handle of a bitmap

   // FirstSample is true the first time the event occurs (useful to know e.g. when a file search must be restarted from the beginning)

   if (FirstSample) {
      if (rdgSearchForBMPorJPEG->ItemIndex == 0) {
         BMPorJPEGFile = SearchForFiles->FirstFile (edtFilesLocation->Text, "*.bmp");
      }
      else {
         BMPorJPEGFile = SearchForFiles->FirstFile (edtFilesLocation->Text, "*.jpg");
      }
   }
   else {
      BMPorJPEGFile = SearchForFiles->NextFile();
   }

   if (BMPorJPEGFile == "") {
      EndOfData = True;
   }
}
//---------------------------------------------------------------------------


